unit Unit_main;

{$mode objfpc}{$H+}

interface

uses
   Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ComCtrls,
   Spin,
   (* StrUtils, *)
   blcksock,
   (* math, *)
   synsock,
   unit_const,
   Unit_TListenerThread (* ,
   Types *)
   ,
   unit_TTCPThread_client
   ;

(*
resourcestring

   rsStart = 'Запустить';
   rsStop = 'Остановить';
   rsConnected = 'Подключено';


const
   const_cReadTimeout = 2000;
   const_size = 2920 (* 17000 *) (* 8000 *) (* 8960 *) (* 47856 *);
   const_SizeBuffer = 100000;
   *)

type

   { TForm1 }

   TForm1 = class(TForm)
      Buttonc_class_client_create: TButton;
      Button_class_client_destroy: TButton;
      Button_set_const_buf_size: TButton;
      Button_free_buf: TButton;
      Button_alloc_buf: TButton;
      Button_client_btnDisConnect: TButton;
      Button_client_SendData: TButton;
      Button_client_dtnSend: TButton;
      Button_client_btnConnect: TButton;
      Button_server_destroy: TButton;
      Button_server_create: TButton;
      ComboBox_client_edAddress: TComboBox;

      Edit_ServerStatus_error: TEdit;
      Edit_client_edAddress: TEdit;
      Edit_client_edPort: TEdit;
      Edit_client_edRequestString: TEdit;

      Label1: TLabel;
      Label_client_lbResponseStr: TLabel;
      Label_client_4: TLabel;
      Label_client_1: TLabel;
      Label_client_2: TLabel;
      Label_client_3: TLabel;
      Label_server_lbAddress: TLabel;
      Label_server: TLabel;

      Memo_log: TMemo;

      PageControl_TCPBlockSocket: TPageControl;
      SpinEdit_buf_size: TSpinEdit;
      SpinEdit_client_num_cycle: TSpinEdit;
      TabSheet_test: TTabSheet;
      TabSheet_server: TTabSheet;
      TabSheet_client: TTabSheet;

      procedure Buttonc_class_client_createClick(Sender: TObject);
      procedure Button_alloc_bufClick(Sender: TObject);
      procedure Button_class_client_destroyClick(Sender: TObject);
      procedure Button_client_btnConnectClick(Sender: TObject);
      procedure Button_client_btnDisConnectClick(Sender: TObject);
      procedure Button_client_dtnSendClick(Sender: TObject);
      procedure Button_client_SendDataClick(Sender: TObject);
      procedure Button_free_bufClick(Sender: TObject);
      procedure Button_server_createClick(Sender: TObject);
      procedure Button_set_const_buf_sizeClick(Sender: TObject);
      procedure ComboBox_client_edAddressChange(Sender: TObject);

      procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);

   private
      Client : TTCPBlockSocket;

   public
      obj_client : TTCPThread_client;
      Server : TListenerThread;
      pBuf : TMemory;
      function alloc_buf( in_size : integer ) : integer;
      function free_buf() : integer;
      function Fillbyte_buf( in_buf : pointer; in_size : integer; in_val : byte ) : integer;

      procedure ServerStatus(Sender: TObject; Reason: THookSocketReason; const Value: String);
   end;

var
   Form1 : TForm1;

implementation

{$R *.lfm}

{ TForm1 }


procedure TForm1.ServerStatus( Sender : TObject; Reason : THookSocketReason; const Value : String );
var
   var_t1, var_t2 : string;
begin
   case Reason of
      HR_Bind : begin
                  self.Memo_log.Lines.Add('ServerStatus: 1: HR_Bind; Value='+Value);
                  var_t1:=self.Server.Socket.GetLocalSinIP+':';
                  var_t2:=IntToStr(self.Server.Socket.GetLocalSinPort);
                  self.Label_server_lbAddress.Caption:=var_t1+var_t2;
                  self.Memo_log.Lines.Add('ServerStatus: 2: HR_Bind: '+self.Label_server_lbAddress.Caption);
               end;

      HR_CanRead : begin (* self.Memo_log.Lines.Add('ServerStatus: HR_CanRead; Value='+Value);  *) end;
      HR_CanWrite : begin (* self.Memo_log.Lines.Add('ServerStatus: HR_CanWrite; Value='+Value);  *) end;
      HR_Listen : self.Memo_log.Lines.Add('ServerStatus: HR_Listen; Value='+Value);
      HR_Accept : self.Memo_log.Lines.Add('ServerStatus: HR_Accept: GetRemoteSinIP='+self.Server.Socket.GetRemoteSinIP+'; Value='+Value);
      HR_ReadCount : begin (* self.Memo_log.Lines.Add('ServerStatus: HR_ReadCount; Value='+Value); *) end;
      HR_WriteCount : begin (* self.Memo_log.Lines.Add('ServerStatus: HR_WriteCount; Value='+Value); *) end;
      HR_Wait : self.Memo_log.Lines.Add('ServerStatus: HR_Wait; Value='+Value);

      HR_Error : begin
                  (* self.Memo_log.Lines.Add('ServerStatus: Error '+self.Server.Socket.LastErrorDesc);  *)
                  self.Edit_ServerStatus_error.Caption:='ServerStatus: HR_Error: LastErrorDesc='+self.Server.Socket.LastErrorDesc+'; Value='+Value;
                  (* self.Memo_log.Lines.Add(self.Edit_ServerStatus_error.Caption); *)
                end;
   end;
end;

procedure TForm1.Button_server_createClick(Sender: TObject);
var
   var_int64_v1, var_int64_v2 : int64;
   var_oldint64_v1 : int64;
   var_time1, var_time2 : TDateTime;
begin
  self.Memo_log.lines.Add('Start');


  if (self.Button_server_create.Caption=rsStart) then
     begin
        self.Server:=TListenerThread.Create(True);
        (* 2000000 *)
        self.Server.num_cycle:=self.SpinEdit_client_num_cycle.Value;
        self.Server.Socket.OnStatus:=@self.ServerStatus;
        self.Server.Start;
        self.Button_server_create.Caption:=rsStop;
     end else
     begin
        self.Server.Terminate;
        self.Server.WaitFor;

        var_int64_v1:=self.Server.int64_v1;
        var_int64_v2:=self.Server.int64_v2;
        var_oldint64_v1:=self.Server.oldint64_v1;
        var_time1:=self.Server.time1;
        var_time2:=self.Server.time2;

        self.Memo_log.Lines.Add('posle self.Server.WaitFor:');
        self.Memo_log.Lines.Add('var_int64_v1='+IntToStr(var_int64_v1));
        self.Memo_log.Lines.Add('var_int64_v2='+IntToStr(var_int64_v2));
        self.Memo_log.Lines.add('DateTimeToStr(var_time1)='+DateTimeToStr(var_time1));
        self.Memo_log.Lines.add('DateTimeToStr(var_time2)='+DateTimeToStr(var_time2));

        self.Memo_log.lines.AddStrings(self.Server.tstr_memo.Text);
        self.Memo_log.lines.Add('Stop');

        (*
        var_time1:=Now();
        self.Memo_log.Lines.add('DateTimeToStr(var_time1)='+DateTimeToStr(var_time1));
        *)

        self.Server.Free;
        self.Button_server_create.Caption:=rsStart;
     end;
end;

procedure TForm1.Button_set_const_buf_sizeClick(Sender: TObject);
begin
   self.SpinEdit_buf_size.Value:=const_size;
end;

procedure TForm1.ComboBox_client_edAddressChange(Sender: TObject);
begin
   self.Edit_client_edAddress.Text:=self.ComboBox_client_edAddress.Text;
end;


procedure TForm1.Button_client_btnConnectClick(Sender: TObject);
begin

  self.alloc_buf(const_size);

  (* создаем объект  *)
  self.Client:=TTCPBlockSocket.Create;

  if (self.Client=nil) then
     begin
        self.Memo_log.Lines.Add('TTCPBlockSocket.Create=nil');
        exit;
     end;

  (*
  SOCK_STREAM     = 1;               { TPGMstreamBlockSocket stream socket }
  SOCK_DGRAM      = 2;               { datagram socket }
  SOCK_RAW        = 3;               { TICMPBlockSocket raw-protocol interface }
  SOCK_RDM        = 4;               { reliably-delivered message }
  SOCK_SEQPACKET  = 5;
  *)

  if(self.Client.GetSocketType=SOCK_STREAM) then
     begin
        self.Memo_log.Lines.Add('self.Client.GetSocketType=SOCK_STREAM');
     end else
     begin
        self.Memo_log.Lines.Add('self.Client.GetSocketType<>SOCK_STREAM');
     end;


 (*
  IPPROTO_IP     =   0;		{ TBlockSocket Dummy					}
  IPPROTO_ICMP   =   1;		{ TICMPBlockSocket Internet Control Message Protocol }
  IPPROTO_IGMP   =   2;		{ Internet Group Management Protocol}
  IPPROTO_TCP    =   6;		{ TTCPBlockSocket TCP           			}
  IPPROTO_UDP    =   17;	{ User Datagram Protocol		}
  IPPROTO_IPV6   =   41;
  IPPROTO_ICMPV6 =   58;   { TICMPBlockSocket }
  IPPROTO_RM     =  113;   { TPGMmessageBlockSocket }
  IPPROTO_RAW    =   255;  { TRAWBlockSocket }
  IPPROTO_MAX    =   256;
 *)

       if(self.Client.GetSocketProtocol=IPPROTO_IP) then
          begin
            self.Memo_log.Lines.Add('self.Client.GetSocketProtocol=IPPROTO_IP');
          end else
          begin
            self.Memo_log.Lines.Add('self.Client.GetSocketProtocol<>IPPROTO_IP');
            self.Memo_log.Lines.Add('self.Client.GetSocketProtocol='+IntToStr(self.Client.GetSocketProtocol));
          end;

      if(self.Client.GetSocketProtocol=IPPROTO_TCP) then
            begin
               self.Memo_log.Lines.Add('self.Client.GetSocketProtocol=IPPROTO_TCP');
            end else
            begin
               self.Memo_log.Lines.Add('self.Client.GetSocketProtocol<>IPPROTO_TCP');
               (* self.Memo_log.Lines.Add('self.Client.GetSocketProtocol='+IntToStr(self.Client.GetSocketProtocol));  *)
            end;

  self.Client.OnStatus:=@self.ServerStatus;

  (* ST_Socks5, ST_Socks4  *)
  (* self.Client.SocksType:=; *)

 (* self.Client.GetSocketProtocol; *)

  (* показываем все исключения Winsock *)
  self.Client.RaiseExcept:=True;

  (* пробуем соединиться с сервером *)
  self.Client.Connect(self.Edit_client_edAddress.Text, self.Edit_client_edPort.Text);
  (* ShowMessage(rsConnected); *)

  self.Client.SizeSendBuffer:=const_SizeBuffer;
  self.Client.SizeRecvBuffer:=self.Client.SizeSendBuffer;

  self.Memo_log.Lines.Add('const_size='+InttoStr(const_size));
  self.Memo_log.Lines.Add('const_SizeBuffer='+InttoStr(const_SizeBuffer));
  self.Memo_log.Lines.Add('self.Client.SizeSendBuffer='+InttoStr(self.Client.SizeSendBuffer));
  self.Memo_log.Lines.Add('self.Client.SizeRecvBuffer='+InttoStr(self.Client.SizeRecvBuffer));

end;

procedure TForm1.Button_alloc_bufClick(Sender: TObject);
var
   res : integer;
begin
   res:=self.alloc_buf(self.SpinEdit_buf_size.Value);
   self.Memo_log.Lines.Add('Button_alloc_bufClick: alloc_buf='+IntToStr(res));
end;

procedure TForm1.Button_class_client_destroyClick(Sender: TObject);
begin
   self.obj_client.Destroy;
end;

procedure TForm1.Buttonc_class_client_createClick(Sender: TObject);
begin
   self.obj_client:=TTCPThread_client.Create(   false (* True *) ,
                                                self.Edit_client_edAddress.Text,
                                                self.Edit_client_edPort.Text,
                                                self.SpinEdit_client_num_cycle.Value  );
   self.obj_client.pMemo_log:=@self.Memo_log;
   self.obj_client.Start;
end;

procedure TForm1.Button_client_btnDisConnectClick(Sender: TObject);
begin
  self.free_buf();

  self.Client.CloseSocket;
  self.Client.Destroy;
end;


procedure TForm1.Button_client_dtnSendClick(Sender: TObject);
var
   var_str : string;
begin
  (* отправляем строку на сервер *)
  self.Client.SendString(self.Edit_client_edRequestString.Text);

  self.Memo_log.Lines.add('self.Client.SendString='+self.Edit_client_edRequestString.Text);

  sleep(1000);

  (* пробуем получить ответ *)
  try
      var_str:=self.Client.RecvPacket(const_cReadTimeout);
  finally
      var_str:='RecvPacket: error';
  end;

  self.Label_client_lbResponseStr.Caption:=var_str;
  self.Memo_log.Lines.add('self.Client.RecvPacket='+self.Label_client_lbResponseStr.Caption);
end;

procedure TForm1.Button_client_SendDataClick(Sender: TObject);
var
   var_pBuffer : pointer;
   var_arr_str : string[255];
   var_pbyte : ^byte;
   var_pchar : ^char;
   var_pint64_v1, var_pint64_v2 : ^int64;
   i, res_SendBuffer, res_RecvBuffer : integer;
   var_time1, var_time2 : TDateTime;
begin
  (*
  var_arr_str:=self.Edit_client_edRequestString.Text;
  var_pBuffer:=@var_arr_str[1];
  *)

  var_pBuffer:=self.pBuf;
  var_pint64_v1:=self.pBuf;
  var_pint64_v2:=self.pBuf+sizeof(int64);


  var_pint64_v1^:=0;
  var_pint64_v2^:=0;

  var_pbyte:=var_pBuffer;
  var_pchar:=var_pBuffer;

  self.Memo_log.Lines.add('1: var_int64_v1='+IntToStr(var_pint64_v1^));
  self.Memo_log.Lines.add('2: var_int64_v2='+IntToStr(var_pint64_v2^));

  (* var_pchar^:=self.Edit_client_edRequestString.Text; *)

  (*
  for i:=0 to const_size do
      begin
         var_pbyte:=var_pBuffer+i;
         var_pbyte^:=i;
      end;
  *)

  (* отправляем строку на сервер *)
  (* self.Client.SendBuffer( var_pBuffer, length(var_arr_str)); *)

   i:=0;
   for i:=0 to self.SpinEdit_client_num_cycle.Value do
        begin
           if (self.Client.CanWrite(1000)) then
              begin
                 (* self.Memo_log.Lines.add('i='+inttostr(i));   *)

                 var_pint64_v1^:=i;
                 res_SendBuffer:=self.Client.SendBuffer( var_pBuffer, const_size );

                 if (res_SendBuffer<>const_size) then
                    begin
                       self.Memo_log.Lines.add('1: error: (res_SendBuffer<>const_size)');
                       self.Memo_log.Lines.add('1: self.Client.SendString='+IntToStr(res_SendBuffer));
                       self.Memo_log.Lines.add('1: const_size='+IntToStr(const_size));
                       self.Memo_log.Lines.add('1: i='+IntToStr(i));
                       break;
                    end else
                    begin
                         if (i=0) then
                            begin
                                 self.Memo_log.Lines.add('1: i='+IntToStr(i));
                                 var_time1:=Now();
                            end;
                    end;

                (* self.Memo_log.Lines.add('self.Client.SendString='+var_arr_str); *)
                (* self.Memo_log.Lines.add('res_SendBuffer='+inttostr(res_SendBuffer)); *)


                 (* var_pbyte:=var_pBuffer; *)

                 (*
                 for i:=0 to 20 (* const_size *) do
                     begin
                        var_pbyte:=var_pBuffer+i;
                        self.Memo_log.Lines.add('buf['+InttoStr(i)+']='+inttostr(var_pbyte^));
                     end;
                 *)

                 (* пробуем получить ответ *)
                 (* self.Label_client_lbResponseStr.Caption:=self.Client.RecvPacket(cReadTimeout); *)

                 (* self.Client.RecvBuffer( var_pBuffer, length(var_arr_str) ); *)

                 if (self.Client.CanRead(1000)) then
                     begin
                       res_RecvBuffer:=self.Client.RecvBuffer( var_pBuffer, const_size );
                       if (res_RecvBuffer<>const_size) then
                          begin
                             self.Memo_log.Lines.add('2: error: self.Client.RecvBuffer='+IntToStr(res_RecvBuffer));
                             self.Memo_log.Lines.add('2: error: const_size='+IntToStr(const_size));
                             self.Memo_log.Lines.add('2: error: i='+IntToStr(i));
                             break;
                          end else
                          begin
                             if ((i<>(var_pint64_v1^)) ) then
                                begin
                                  self.Memo_log.Lines.add('3: error: i='+IntToStr(i)+'; var_pint64_v1='+IntToStr(var_pint64_v1^)+'; var_pint64_v2='+IntToStr(var_pint64_v2^));
                                end;

                             if (((1+var_pint64_v1^)<>(var_pint64_v2^))) then
                                begin
                                  self.Memo_log.Lines.add('33: error: i='+IntToStr(i)+'; var_pint64_v1='+IntToStr(var_pint64_v1^)+'; var_pint64_v2='+IntToStr(var_pint64_v2^));
                                end;

                             (*
                             self.Memo_log.Lines.add('i:='+IntToStr(i)+'; RecvBuffer: '+'var_int64_v1='+IntToStr(var_pint64_v1^)+ '; var_int64_v2='+IntToStr(var_pint64_v2^));
                             *)
                          end;

                          (* self.Label_client_lbResponseStr.Caption:=var_arr_str; *)
                        (*  self.Memo_log.Lines.add( 'self.Client.RecvPacket='+self.Label_client_lbResponseStr.Caption); *)

                           (*
                           self.Memo_log.Lines.add('res_RecvBuffer='+inttostr(res_RecvBuffer));
                           self.Memo_log.Lines.add('RecvBuffer:');        *)

                           (*
                           self.Memo_log.Lines.add('3: var_int64_v1='+IntToStr(var_pint64_v1^));
                           self.Memo_log.Lines.add('4: var_int64_v2='+IntToStr(var_pint64_v2^));
                           *)

                           (*
                           for i:=0 to 20 (* const_size *) do
                               begin
                                  var_pbyte:=var_pBuffer+i;
                                  self.Memo_log.Lines.add('buf['+InttoStr(i)+']='+inttostr(var_pbyte^));
                               end;
                           *)
                     end;

              end;
        end;

        var_time2:=Now();

        self.Memo_log.Lines.add('DateTimeToStr(var_time1)='+DateTimeToStr(var_time1));
        self.Memo_log.Lines.add('DateTimeToStr(var_time2)='+DateTimeToStr(var_time2));


         self.Memo_log.Lines.add('end cycle:');
         self.Memo_log.Lines.add('5: var_int64_v1='+IntToStr(var_pint64_v1^));
         self.Memo_log.Lines.add('6: var_int64_v2='+IntToStr(var_pint64_v2^));
         self.Memo_log.Lines.add('7: i='+IntToStr(i));

end;

procedure TForm1.Button_free_bufClick(Sender: TObject);
var
   res : integer;
begin
   res:=self.free_buf();
   self.Memo_log.Lines.Add('Button_free_bufClick: free_buf='+IntToStr(res));
end;

procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  if (self.Button_server_create.Caption=rsStop) then
     begin
        self.Server.Terminate;
        self.Server.WaitFor;
        self.Server.Free;
     end;
end;



function TForm1.alloc_buf( in_size : integer ) : integer;
begin
	   if (in_size>0) then
	     begin
	       result:=0;
	     end else
	     begin
	       result:=-1;
          exit;
	     end;

	     self.pBuf:=PChar(AllocMem(in_size (* self.size *) ));

        (* self.size *)

        if (self.pBuf<>nil) then
          begin
	         self.Fillbyte_buf( self.pBuf, in_size  , 0 );
          end else
          begin
            result:=-2;
          end;

end;

function TForm1.free_buf() : integer;
begin
      if (self.pBuf<>nil) then
        begin
		    FreeMem(self.pBuf);
		    self.pBuf:=nil;
          result:=0;
		  end else
        begin
          result:=-1;
		  end;
end;

function TForm1.Fillbyte_buf( in_buf : pointer; in_size : integer; in_val : byte ) : integer;
var
   var_pv_buf : ^byte;
   var_i, var_res : integer;
begin
  var_res:=0;

  if (in_buf=nil) then
    begin
      var_res:=-1;
      result:=var_res;
      exit;
    end;

    if (in_size<1) then
      begin
        var_res:=-2;
        result:=var_res;
        exit;
      end;

    for var_i:=0 to (in_size-1) do
         begin
           var_pv_buf:=in_buf+var_i;
           var_pv_buf^:=in_val;
         end;

    result:=var_res;
end;




end.

