unit Unit_TTCPThread;

{$mode ObjFPC}{$H+}

interface

uses
   Classes, SysUtils,
   blcksock,
   synsock,
   LazUTF8,
   unit_const;

(*
const
     const_cReadTimeout = 2000;
     const_size = 2920 (* 17000 *) (* 8000 *) (* 8960 *) (* 47856 *);
     const_SizeBuffer = 100000;
*)

type

TTCPThread = class(TThread)
   private
      FSocket: TTCPBlockSocket;

      {Обрабатывает полученные от клиента данные и отправляет их обратно}
      procedure ProcessingData( const in_AData: string );

   protected
      procedure Execute; override;

   public
      pBuf : TMemory;
      num_cycle : integer;
      pint64_v1, pint64_v2 : ^int64;
      oldint64_v1 : int64;
      time1, time2 : TDateTime;

      function alloc_buf( in_size : integer ) : integer;
      function free_buf() : integer;
      function Fillbyte_buf( in_buf : pointer; in_size : integer; in_val : byte ) : integer;
      //ASocket - дескриптор сокета из очереди подключений.

      constructor Create( var_ASyspended: boolean; var_ASocket: integer);
      destructor Destroy; override;

      property Socket : TTCPBlockSocket read FSocket;
end;

implementation


(* TTCPThread *)
constructor TTCPThread.Create( var_ASyspended: boolean; var_ASocket: integer);
begin
   self.alloc_buf(const_size);

   self.FSocket:=TTCPBlockSocket.Create;
   self.FSocket.Socket:=var_ASocket;
   self.FSocket.GetSins;

   (* var_ASocket.SetTimeout(2000); *)
   self.FSocket.SetTimeout(const_cReadTimeout);

   self.FSocket.SizeSendBuffer:=const_SizeBuffer;
   self.FSocket.SizeRecvBuffer:=self.FSocket.SizeSendBuffer;

   inherited Create(var_ASyspended);

   self.time1:=Now();
   self.time2:=Now();
end;

destructor TTCPThread.Destroy;
begin
   self.free_buf();
   FSocket.Free;
   inherited;
end;

procedure TTCPThread.Execute;
var
   var_S : string;
   res_RecvBuffer : integer;
   var_pbyte : ^byte;
   var_i : integer;
begin
   var_i:=0;
   var_s:='11111111111111111111';

   self.time1:=0;
   self.time2:=0;
   (* var_oldtime1
   var_time2 *)

   self.pint64_v1:=self.pBuf;
   self.pint64_v2:=self.pBuf+sizeof(int64);

   (* работаем пока не поступит сигнал на остановку *)
   while not Terminated do
      begin
         (* есть данные ожидающие чтения *)
(*         if (FSocket.WaitingData=0) then   *)
           if (self.FSocket.CanRead(1000)) then
               begin
                   (* получаем данные *)
                   (* s:=self.FSocket.RecvPacket(2000); *)
                    res_RecvBuffer:=self.FSocket.RecvBuffer( self.pBuf, const_size );

                    self.pint64_v2^:=(self.pint64_v1^)+1;
                    self.oldint64_v1:=self.pint64_v1^;

                    (*
                    if (var_i<>self.pint64_v1^) then
                        begin
                           self.time2:=Now();
                       (*    self.FSocket.CloseSocket;
                           self.DoTerminate;
                           break;               *)
                        end;
                    *)

                    if (self.pint64_v1^=0) then
                        begin
                           self.time1:=Now();
                           (* self.time2:=self.time1; *)
                        end;

                    if (self.pint64_v1^=(self.num_cycle-1)) then
                        begin
                           self.time2:=Now();
                        end;

                    (*
                      for i:=0 to const_size do
                           begin
                              var_pbyte:=self.pBuf+i;
                              var_pbyte^:=10*i;
                           end;
                     *)

                     (* ошибок при получении данных не было *)
                  (*   if self.FSocket.LastError = 0 then *)
                        begin
                           (* обрабатываем данные *)
                            self.ProcessingData(var_S);
                        end;
               end;
         (* sleep(10); *) (* "спим" 10 миллисекунд *)
      end;
end;

procedure TTCPThread.ProcessingData( const in_AData : string );
var
  res_SendBuffer : integer;
begin
   (* есть какой-то текст *)
   if (Length(in_AData)<>0) then
      begin
         if (self.FSocket.CanWrite(1000)) then
              begin
                  (* "переворачиваем" строку и отправляем обратно клиенту *)
                  (* self.FSocket.SendString(UTF8ReverseString(var_AData)); *)
                  res_SendBuffer:=self.FSocket.SendBuffer( self.pBuf, const_size );
              end;
      end;
end;



function TTCPThread.alloc_buf( in_size : integer ) : integer;
var
  var_res : integer;
begin
	   if (in_size>0) then
	     begin
	       result:=0;
	     end else
	     begin
	       result:=-1;
          exit;
	     end;

	     self.pBuf:=PChar(AllocMem(in_size (* self.size *) ));

        (* self.size *)

        if (self.pBuf<>nil) then
          begin
	         var_res:=self.Fillbyte_buf( self.pBuf, in_size  , 0 );
            if (var_res<>0) then
              begin
                result:=-3;
              end;
          end else
          begin
            result:=-2;
          end;
end;

function TTCPThread.free_buf() : integer;
begin
      if (self.pBuf<>nil) then
        begin
		    FreeMem(self.pBuf);
		    self.pBuf:=nil;
          result:=0;
		  end else
        begin
          result:=-1;
		  end;
end;


function TTCPThread.Fillbyte_buf( in_buf : pointer; in_size : integer; in_val : byte ) : integer;
var
   var_pv_buf : ^byte;
   var_i, var_res : integer;
begin
  var_res:=0;

  if (in_buf=nil) then
    begin
      var_res:=-1;
      result:=var_res;
      exit;
    end;

    if (in_size<1) then
      begin
        var_res:=-2;
        result:=var_res;
        exit;
      end;

    for var_i:=0 to (in_size-1) do
         begin
           var_pv_buf:=in_buf+var_i;
           var_pv_buf^:=in_val;
         end;

    result:=var_res;
end;

end.

