unit unit_TTCPThread_client;

{$mode ObjFPC}{$H+}

interface

uses
   Classes, SysUtils,
   blcksock,
   synsock,
   LazUTF8,
   StdCtrls,
   unit_const;

(*
const
     const_cReadTimeout = 2000;
     const_size = 2920 (* 17000 *) (* 8000 *) (* 8960 *) (* 47856 *);
     const_SizeBuffer = 100000;
*)


type

TTCPThread_client = class(TThread)
   private
      (* FSocket: TTCPBlockSocket; *)

      (* procedure ProcessingData( const in_AData: string ); *)

      (* Обрабатывает полученные от клиента данные и отправляет их обратно *)

   protected
      procedure Execute; override;

   public
      SpinEdit_client_num_cycle_Value : int64;

      pBuf : TMemory;
      num_cycle : integer;
      pint64_v1, pint64_v2 : ^int64;
      oldint64_v1 : int64;
      time1, time2 : TDateTime;
      (*
      var_time1, var_time2 : TDateTime;
      *)

      Edit_client_edAddress_Text : string;
      Edit_client_edPort_Text : string;

      Client : TTCPBlockSocket;
      pMemo_log : ^TMemo;

      function Connect : integer;

      function alloc_buf( in_size : integer ) : integer;
      function free_buf() : integer;
      function Fillbyte_buf( in_buf : pointer; in_size : integer; in_val : byte ) : integer;
      (* ASocket - дескриптор сокета из очереди подключений. *)

      constructor Create( var_ASyspended : boolean (* ; var_ASocket: integer *); in_edAddress : string; in_edPort : string;  in_num_cycle : int64 );
      destructor Destroy; override;

      procedure ServerStatus( Sender : TObject; Reason : THookSocketReason; const Value : String );

      (* property Socket : TTCPBlockSocket read FSocket; *)
end;


implementation


procedure TTCPThread_client.ServerStatus( Sender : TObject; Reason : THookSocketReason; const Value : String );
var
   var_t1, var_t2 : string;
   var_label : string;
begin
   var_t1:='';
   var_t2:='';
   var_label:='';

   case Reason of
      HR_Bind : begin
                 self.pMemo_log^.Lines.Add('ServerStatus: 1: HR_Bind; Value='+Value);
                 var_t1:=self.Client.GetLocalSinIP+':';
                 var_t2:=IntToStr(self.Client.GetLocalSinPort);
                 (* self.Label_server_lbAddress.Caption:=var_t1+var_t2; *)
                 var_label:=var_t1+var_t2;
                 self.pMemo_log^.Lines.Add('ServerStatus: 2: HR_Bind: '+var_label);
               end;

      HR_CanRead : begin
                     (* self.Memo_log.Lines.Add('ServerStatus: HR_CanRead; Value='+Value);  *)
                  end;

      HR_CanWrite : begin
                     (* self.Memo_log.Lines.Add('ServerStatus: HR_CanWrite; Value='+Value);  *)
                     end;

      HR_Listen : begin
                   self.pMemo_log^.Lines.Add('ServerStatus: HR_Listen; Value='+Value);
                  end;

      HR_Accept : begin
                   (* self.pMemo_log^.Lines.Add('ServerStatus: HR_Accept: GetRemoteSinIP='+self.Server.Socket.GetRemoteSinIP+'; Value='+Value); *)
                   self.pMemo_log^.Lines.Add('ServerStatus: HR_Accept: ');
                  end;

      HR_ReadCount : begin
                     (* self.Memo_log.Lines.Add('ServerStatus: HR_ReadCount; Value='+Value); *)
                     end;

      HR_WriteCount : begin
                     (* self.Memo_log.Lines.Add('ServerStatus: HR_WriteCount; Value='+Value); *)
                     end;

      HR_Wait : begin
                   self.pMemo_log^.Lines.Add('ServerStatus: HR_Wait; Value='+Value);
               end;

      HR_Error : begin
                   (* self.pMemo_log^.Lines.Add('ServerStatus: Error '+self.Server.Socket.LastErrorDesc); *)
                   self.pMemo_log^.Lines.Add('ServerStatus: Error '+self.Client.LastErrorDesc);
                (*   self.Edit_ServerStatus_error.Caption:='ServerStatus: HR_Error: LastErrorDesc='+self.Server.Socket.LastErrorDesc+'; Value='+Value;   *)
                (*   self.pMemo_log^.Lines.Add(self.Edit_ServerStatus_error.Caption);  *)
                end;
   end;
end;

(* TTCPThread *)
constructor TTCPThread_client.Create( var_ASyspended: boolean (* ; var_ASocket: integer *) ; in_edAddress : string; in_edPort : string; in_num_cycle : int64 );
var
   var_res : integer;
begin
   self.Edit_client_edAddress_Text:=in_edAddress;
   self.Edit_client_edPort_Text:=in_edPort;
   self.SpinEdit_client_num_cycle_Value:=in_num_cycle;

   self.alloc_buf(const_size);

   (*
   self.FSocket:=TTCPBlockSocket.Create;
   self.FSocket.Socket:=var_ASocket;
   self.FSocket.GetSins;
   *)

   (* var_ASocket.SetTimeout(2000); *)
   (*
   self.FSocket.SetTimeout(const_cReadTimeout);

   self.FSocket.SizeSendBuffer:=const_SizeBuffer;
   self.FSocket.SizeRecvBuffer:=self.FSocket.SizeSendBuffer;
   *)


   inherited Create(var_ASyspended);
end;

destructor TTCPThread_client.Destroy;
begin
   self.free_buf();
   (* FSocket.Free; *)
   inherited;
end;

function TTCPThread_client.Connect : integer;
begin
      result:=0;

     (* self.alloc_buf(const_size); *)

     (* создаем объект  *)
     self.Client:=TTCPBlockSocket.Create;

     if (self.Client=nil) then
        begin
           (* self.Memo_log.Lines.Add('TTCPBlockSocket.Create=nil');   *)
           exit;
        end;

     (*
     SOCK_STREAM     = 1;               { TPGMstreamBlockSocket stream socket }
     SOCK_DGRAM      = 2;               { datagram socket }
     SOCK_RAW        = 3;               { TICMPBlockSocket raw-protocol interface }
     SOCK_RDM        = 4;               { reliably-delivered message }
     SOCK_SEQPACKET  = 5;
     *)

     if(self.Client.GetSocketType=SOCK_STREAM) then
        begin
           self.pMemo_log^.Lines.Add('self.Client.GetSocketType=SOCK_STREAM');
        end else
        begin
           self.pMemo_log^.Lines.Add('self.Client.GetSocketType<>SOCK_STREAM');
        end;


    (*
     IPPROTO_IP     =   0;		{ TBlockSocket Dummy					}
     IPPROTO_ICMP   =   1;		{ TICMPBlockSocket Internet Control Message Protocol }
     IPPROTO_IGMP   =   2;		{ Internet Group Management Protocol}
     IPPROTO_TCP    =   6;		{ TTCPBlockSocket TCP           			}
     IPPROTO_UDP    =   17;	{ User Datagram Protocol		}
     IPPROTO_IPV6   =   41;
     IPPROTO_ICMPV6 =   58;   { TICMPBlockSocket }
     IPPROTO_RM     =  113;   { TPGMmessageBlockSocket }
     IPPROTO_RAW    =   255;  { TRAWBlockSocket }
     IPPROTO_MAX    =   256;
    *)

          if(self.Client.GetSocketProtocol=IPPROTO_IP) then
             begin
               (* self.Memo_log.Lines.Add('self.Client.GetSocketProtocol=IPPROTO_IP'); *)
             end else
             begin
               (*
               self.Memo_log.Lines.Add('self.Client.GetSocketProtocol<>IPPROTO_IP');
               self.Memo_log.Lines.Add('self.Client.GetSocketProtocol='+IntToStr(self.Client.GetSocketProtocol));
               *)
             end;

         if(self.Client.GetSocketProtocol=IPPROTO_TCP) then
               begin
                  (* self.Memo_log.Lines.Add('self.Client.GetSocketProtocol=IPPROTO_TCP');   *)
               end else
               begin
                 (*
                  self.Memo_log.Lines.Add('self.Client.GetSocketProtocol<>IPPROTO_TCP');
                  *)
                  (* self.Memo_log.Lines.Add('self.Client.GetSocketProtocol='+IntToStr(self.Client.GetSocketProtocol));  *)
               end;

     self.Client.OnStatus:=@self.ServerStatus;

     (* ST_Socks5, ST_Socks4  *)
     (* self.Client.SocksType:=; *)

    (* self.Client.GetSocketProtocol; *)

     (* показываем все исключения Winsock *)
     self.Client.RaiseExcept:=True;

     (* пробуем соединиться с сервером *)
     self.Client.Connect( self.Edit_client_edAddress_Text, self.Edit_client_edPort_Text );
     (* ShowMessage(rsConnected); *)

     self.Client.SizeSendBuffer:=const_SizeBuffer;
     self.Client.SizeRecvBuffer:=self.Client.SizeSendBuffer;

     (*
     self.Memo_log.Lines.Add('const_size='+InttoStr(const_size));
     self.Memo_log.Lines.Add('const_SizeBuffer='+InttoStr(const_SizeBuffer));
     self.Memo_log.Lines.Add('self.Client.SizeSendBuffer='+InttoStr(self.Client.SizeSendBuffer));
     self.Memo_log.Lines.Add('self.Client.SizeRecvBuffer='+InttoStr(self.Client.SizeRecvBuffer));
     *)
end;

procedure TTCPThread_client.Execute;
var
   var_S : string;
   res_RecvBuffer : integer;
   var_pbyte : ^byte;
   var_i : integer;
   var_pBuffer : pointer;
   var_arr_str : string[255];
   (* var_pbyte : ^byte; *)
   var_pchar : ^char;
   var_pint64_v1, var_pint64_v2 : ^int64;
   var_res, i, res_SendBuffer (* , res_RecvBuffer *) : integer;
   var_error_read : integer;
begin

   self.pMemo_log^.Lines.add('Start TTCPThread_client');

   var_res:=self.Connect();


   self.time1:=Now();
   self.time2:=Now();

   (*
   var_arr_str:=self.Edit_client_edRequestString.Text;
   var_pBuffer:=@var_arr_str[1];
   *)

   var_pBuffer:=self.pBuf;
   var_pint64_v1:=self.pBuf;
   var_pint64_v2:=self.pBuf+sizeof(int64);

   var_pint64_v1^:=0;
   var_pint64_v2^:=0;

   var_pbyte:=var_pBuffer;
   var_pchar:=var_pBuffer;


   self.pMemo_log^.Lines.add('1: var_int64_v1='+IntToStr(var_pint64_v1^));
   self.pMemo_log^.Lines.add('2: var_int64_v2='+IntToStr(var_pint64_v2^));


   (* var_pchar^:=self.Edit_client_edRequestString.Text; *)

   (*
   for i:=0 to const_size do
       begin
          var_pbyte:=var_pBuffer+i;
          var_pbyte^:=i;
       end;
   *)

   (* отправляем строку на сервер *)
   (* self.Client.SendBuffer( var_pBuffer, length(var_arr_str)); *)

    i:=0;
    for i:=0 to self.SpinEdit_client_num_cycle_Value do
         begin
            if (self.Client.CanWrite(1000)) then
               begin
                  (* self.Memo_log.Lines.add('i='+inttostr(i));   *)

                  var_pint64_v1^:=i;
                  res_SendBuffer:=self.Client.SendBuffer( var_pBuffer, const_size );

                  if (res_SendBuffer<>const_size) then
                     begin
                        self.pMemo_log^.Lines.add('1: error: (res_SendBuffer<>const_size)');
                        self.pMemo_log^.Lines.add('1: self.Client.SendString='+IntToStr(res_SendBuffer));
                        self.pMemo_log^.Lines.add('1: const_size='+IntToStr(const_size));
                        self.pMemo_log^.Lines.add('1: i='+IntToStr(i));
                        break;
                     end else
                     begin
                          if (i=0) then
                             begin
                                  (* self.Memo_log.Lines.add('1: i='+IntToStr(i)); *)
                                  self.time1:=Now();
                             end;
                     end;

                 (* self.Memo_log.Lines.add('self.Client.SendString='+var_arr_str); *)
                 (* self.Memo_log.Lines.add('res_SendBuffer='+inttostr(res_SendBuffer)); *)


                  (* var_pbyte:=var_pBuffer; *)

                  (*
                  for i:=0 to 20 (* const_size *) do
                      begin
                         var_pbyte:=var_pBuffer+i;
                         self.Memo_log.Lines.add('buf['+InttoStr(i)+']='+inttostr(var_pbyte^));
                      end;
                  *)

                  (* пробуем получить ответ *)
                  (* self.Label_client_lbResponseStr.Caption:=self.Client.RecvPacket(cReadTimeout); *)

                  (* self.Client.RecvBuffer( var_pBuffer, length(var_arr_str) ); *)

                  var_error_read:=0;

                  if (self.Client.CanRead(1000)) then
                      begin
                        res_RecvBuffer:=self.Client.RecvBuffer( var_pBuffer, const_size );
                        if (res_RecvBuffer<>const_size) then
                           begin
                              self.pMemo_log^.Lines.add('2: error: self.Client.RecvBuffer='+IntToStr(res_RecvBuffer));
                              self.pMemo_log^.Lines.add('2: error: const_size='+IntToStr(const_size));
                              self.pMemo_log^.Lines.add('2: error: i='+IntToStr(i));
                              var_error_read:=1;
                              (* break; *)
                           end else
                           begin
                              if ((i<>(var_pint64_v1^)) ) then
                                 begin
                                   self.pMemo_log^.Lines.add('3: error: i='+IntToStr(i)+'; var_pint64_v1='+IntToStr(var_pint64_v1^)+'; var_pint64_v2='+IntToStr(var_pint64_v2^));
                                   var_error_read:=var_error_read+20;
                                   (* break; *)
                                 end;

                              if (((1+var_pint64_v1^)<>(var_pint64_v2^))) then
                                 begin
                                   self.pMemo_log^.Lines.add('33: error: i='+IntToStr(i)+'; var_pint64_v1='+IntToStr(var_pint64_v1^)+'; var_pint64_v2='+IntToStr(var_pint64_v2^));
                                   var_error_read:=var_error_read+300;
                                   (* break; *)
                                 end;

                              (*
                              self.Memo_log.Lines.add('i:='+IntToStr(i)+'; RecvBuffer: '+'var_int64_v1='+IntToStr(var_pint64_v1^)+ '; var_int64_v2='+IntToStr(var_pint64_v2^));
                              *)
                           end;

                           (* self.Label_client_lbResponseStr.Caption:=var_arr_str; *)
                         (*  self.Memo_log.Lines.add( 'self.Client.RecvPacket='+self.Label_client_lbResponseStr.Caption); *)

                            (*
                            self.Memo_log.Lines.add('res_RecvBuffer='+inttostr(res_RecvBuffer));
                            self.Memo_log.Lines.add('RecvBuffer:');        *)

                            (*
                            self.Memo_log.Lines.add('3: var_int64_v1='+IntToStr(var_pint64_v1^));
                            self.Memo_log.Lines.add('4: var_int64_v2='+IntToStr(var_pint64_v2^));
                            *)

                            (*
                            for i:=0 to 20 (* const_size *) do
                                begin
                                   var_pbyte:=var_pBuffer+i;
                                   self.Memo_log.Lines.add('buf['+InttoStr(i)+']='+inttostr(var_pbyte^));
                                end;
                            *)
                      end;

               end;
            sleep(2);
         end;

         self.time2:=Now();

         self.pMemo_log^.Lines.add('DateTimeToStr(var_time1)='+DateTimeToStr(self.time1));
         self.pMemo_log^.Lines.add('DateTimeToStr(var_time2)='+DateTimeToStr(self.time2));
         self.pMemo_log^.Lines.add('Stop TTCPThread_client');


         (*
          self.Memo_log.Lines.add('end cycle:');
          self.Memo_log.Lines.add('5: var_int64_v1='+IntToStr(var_pint64_v1^));
          self.Memo_log.Lines.add('6: var_int64_v2='+IntToStr(var_pint64_v2^));
          self.Memo_log.Lines.add('7: i='+IntToStr(i));
         *)
end;


(*
procedure TTCPThread_client.ProcessingData( const in_AData : string );
var
  res_SendBuffer : integer;
begin
   (* есть какой-то текст *)
   if (Length(in_AData)<>0) then
      begin
        (* if (self.FSocket.CanWrite(1000)) then    *)
              begin
                  (* "переворачиваем" строку и отправляем обратно клиенту *)
                  (* self.FSocket.SendString(UTF8ReverseString(var_AData)); *)
                  (* res_SendBuffer:=self.FSocket.SendBuffer( self.pBuf, const_size );    *)
              end;
      end;
end;
*)


function TTCPThread_client.alloc_buf( in_size : integer ) : integer;
var
  var_res : integer;
begin
	   if (in_size>0) then
	     begin
	       result:=0;
	     end else
	     begin
	       result:=-1;
          exit;
	     end;

	     self.pBuf:=PChar(AllocMem(in_size (* self.size *) ));

        (* self.size *)

        if (self.pBuf<>nil) then
          begin
	         var_res:=self.Fillbyte_buf( self.pBuf, in_size  , 0 );
            if (var_res<>0) then
              begin
                result:=-3;
              end;
          end else
          begin
            result:=-2;
          end;
end;

function TTCPThread_client.free_buf() : integer;
begin
      if (self.pBuf<>nil) then
        begin
		    FreeMem(self.pBuf);
		    self.pBuf:=nil;
          result:=0;
		  end else
        begin
          result:=-1;
		  end;
end;


function TTCPThread_client.Fillbyte_buf( in_buf : pointer; in_size : integer; in_val : byte ) : integer;
var
   var_pv_buf : ^byte;
   var_i, var_res : integer;
begin
  var_res:=0;

  if (in_buf=nil) then
    begin
      var_res:=-1;
      result:=var_res;
      exit;
    end;

    if (in_size<1) then
      begin
        var_res:=-2;
        result:=var_res;
        exit;
      end;

    for var_i:=0 to (in_size-1) do
         begin
           var_pv_buf:=in_buf+var_i;
           var_pv_buf^:=in_val;
         end;

    result:=var_res;
end;


end.

